/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 	JSClass OOP parser/interpreter 
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
 Author:  Bart Bizon <dev@bartbizon.com> 
 WebSite: http://sourceforge.net/projects/jsclass 
 Version: 0.5 
 License: GNU LGPL 
   	
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^*/ 



Browser=new (function Browser() {
  var n=navigator,b=n.appName,v=n.vendorSub||n.appVersion,u=n.userAgent,t=this,s,ver;
  if(b=="Netscape"){ 
    ver=parseInt(v)
    s=(b="NS")+(ver==5?6:ver)    
  }else if(u.indexOf("Opera")>0||b=="Opera"){ 
    v=u.slice(u.indexOf("Opera")+6)
    s="Opera5"
  }else{    
    v=v.slice(v.indexOf("MSIE")+5)
    ver=v.slice(0,2)
    s=(b="IE")+ver.replace(/\.|0/g,"")
  }  
  t.DOM=document.getElementById?true:false
  t.version=parseFloat(v)
  t.name=s
  t[s]=t[b]=true  
  t[t.platform=u.indexOf("Win")>-1?"WIN":u.indexOf("Mac")>-1?"MAC":"N/A"]=true;  
});

Abstract=null;


p=Function.prototype
t=p.Extends=function(S){ //enables subclassing of all Functions  
  if(!S) return ; // ASSERT
  var s=this.toString(),t=this,cN=t.Name||(t.Name=s.slice(s.indexOf("function")+9,s.indexOf("(")))
  
  if(!cN){  	  	
  	t._e=S
  	return // ASSERT, extending class has no name
  }
  
  var eL=JSC._exL,SN;
  if(typeof S=="function"){
    if(!S.Name){
      s=S.toString()
      S.Name=s.slice(s.indexOf("function"),s.indexOf("("))            
    }
    SN=S.Name    
  }else if(S.constructor==String) SN=S  
  else return; // ASSERT,
  
  eL=eL[SN]||(eL[SN]=[]) // references /and creates the extended class stuff
  eL[eL.length]=t //cN // stores the name of the class that extends
  
} 
t._=1
t=p.Decorates=function(c){ 
	var L=JSC._dL;
	if(typeof c=="object"){
		if(c.length)
			for(var i=0;i<c.length;i++){
				L[L.length]=[c[i],this]	
			}
		else L=[[c,this]]
		
		JSC._decorate(L)
		return 
	}
	L[L.length]=[c,this]
} // enables file independant growing of/adding to Classes 
t._=1
t=p.Applies=function(c){ var L=JSC._dL;L[L.length]=[this,c] }
t._=1
//p.toSource=p.toString
t=p.toSource=function(){
	var s=this.toString()
	return s.slice(s.indexOf("{")+1,s.lastIndexOf("}"))	
}
t._=1

// NOTE: decorator name check and put

J=JSC=JSClass=function JSClass(){}
J.Name="JSClass"
J._Uc=1 // UIDcount 



J._i=[] // == instances

J._c={ JSClass: JSC } // == Classes
J._d={} // Decorators
J._si={} // Singletons
J._s=[] // Static constructor classes, 
J._iv={} //intervals
J._p={} // packaged classes, classes and what package they belong to 
//JSC.Macros={}

p=J._pub={ JSClass:function(){} } // Public
J._pro={} // Protected
J._pri={} // Private 

p=p.JSClass.prototype={   // Public 
  getUID:function(){ return this["$UID"] },
  //applyDecorator:function(o){},
  getClass:function(){ return this.Class },
  getGlobal:function(){ // returns global string representation of object
  	return "JSC._i["+this['$UID']+"]"  	
  },
  destroy:function(){  	  	
  	//this.constructor=null
  	for(var i in this) this[i]=null  	
  }  
  
}
/*s="var J=JSC;if(C==JSC) return true; if(typeof C=='String'&&!(C=J._c[C])) return false; "
p.instanceOf=Browser.DOM?
  new Function("C",s+"return this instanceof C") :
  new Function("C",s+function(){  	
    var c=C.Class,o=this.Class
    for(var cN=c.name;o.name!=JSC.Name;o=o.Super)
      if(cN==o.name) return true;
    return false;
  })

*/
p.instanceOf=function(C){
	if(!C) return;
	C=typeof C=="string"?C:C.Class?C.Class.name:0
	
	return this["is"+C]	
}


J._sp={ // == StaPub == StaticPublic	// NOTE: this might be called in the incorrect scope, if not copied down the inheritance chain	
  getInstances:function(deep){ // makes a copy  	
  	var C=JSC._c,c=this,eL=JSC._exL[c.Class.name],a=[].concat(c['@i'])  	  	
  	if(deep) for(var i=0;i<eL.length;i++) a=a.concat(C[eL[i]].getInstances())	
  	return a  	
  }	
}

J._exL={} // == extendList
J._dL=[] // == decList == decoratorList
J._iL=[] // == importList
J._nL=["toString","valueOf"] // == nativeList

t=J._t={
	t0:(Public="Public"),
	t1:(Protected="Protected"),
	t2:(Private="Private"),
	t3:"Static",
	t4:"Package",
	t5:"prototype",
	t6:"Singleton",
	t7:"Abstract"	
}
s="var c=arguments.callee;/* if(t['$UID'])JSC._ar=t; else t=JSC._ar;*/ with(this){ Class.Scope=c['C'];Super=c.Super;c=null;"
t.ss="with(this){"
t.s=[s,s,s,t.ss,t.ss] // strings for method replacing
with(t){t.ty=[t0,t1,t2,t3+"."+t0,t3+"."+t1]}
 

J._aN={} // == accName == accessorName
//J.setAccessorRef=function(a,n){ if(!JSC.parsed) JSC._aN[a]=n }

J.addNative=function(){
  var a=arguments,n=JSC._nL; 
  for(var i=0;i<a.length;i++) if(Object.prototype[a[i]]) n[n.length]=a[i]
}

J.enablesLoadEvents=function(c){ with(JSC){
	c.addLoadEvent=addLoadEvent
	c.addInitEvent=addInitEvent
 	c.addAfterLoadEvent=addAfterLoadEvent
}}

J._evL=[] // == eventList

J._addE=function(t,f){ // == addEventType
   
  if(typeof f!="function"||f._JSCe) return; // duplicates are not allowed.     
  f._JSCe=true
 
  var L=JSC._evL[t]||(JSC._evL[t]=[])         
  L[L.length]=f  
}
J.addLoadEvent=function(f){ JSC._addE("LOAD",f) }
J.addInitEvent=function(f){ JSC._addE("INIT",f) }
J.addAfterLoadEvent=function(f){ JSC._addE("AFTERLOAD",f) }
J.addUnloadEvent=function(f){ JSC._addE("UNLOAD",f) }

J._fireE=function(){  // fires the load events added
  var a=arguments   
  for(var i=0;i<a.length;i++){
  	var e=JSC._evL[a[i]]  	
  	for(var n in e)	e[n]()  	
  }		
}

J.getInstance=function(n){
  return JSC._i[n]
}



J._decorate=function(dL){with(JSC){with(_t){
	var t=[t0,t1,t2,t3]
	//alert("decorating")
	
	
	for(var nn=0;nn<dL.length;nn++){
    var C=dL[nn][0],D=dL[nn][1],I=(typeof C=="object") // C= class to be decorated, D = the decorator
        
    if(typeof C=="string") C=window[C]||C //NOTE: might be a namespace issue
    if(typeof D=="string") D=window[D]||D
    
    var d,DT=[D[t0],D[t1],D[t2]],c=(I?C:C[t0])||(C[t0]={}),CT=[c,c,c]    
    
    if(!I&&(d=D[t3])){ // D.Static			
      DT[3]=d[t0] // D.Static.Public
      DT[4]=d[t1] // D.Static.Protected      
      c=C[t3]||(C[t3]={})			// c.Static
      CT[3]=CT[4]=c[t0]||(c[t0]={}) // c.Static.Public & protected    	
    }
    
    if(!D['$p']){ //only parse once
    	
    	_parseMethods(DT,DT) // parsing the decorator
    	D['$p']=true //parsed
    }
    
    for(var i=0;i<DT.length;i++){
      if(!(D=DT[i])) continue;    
      for(var n=0;n<_nL.length;n++) if(D[_nL[n]]!=Object.prototype[_nL[n]]) D[i]=D[_nL[n]]; // ex. D.0="toString"		  
      C=CT[i]      
      for(var n in D){         	
      	if(_nL[n]) n=_nL[n] // if this is native function, ex. n=0  	
      	d=D[n];c=C[n]
      	if(typeof c=="function"&&typeof d=="function"){
      		if(I){ // under the assumption that the instance beeing decorated is parsed      		
      			C[n]=d
      			d.Orig=c
      		}else	c._p=d // the parsed method
      	}else C[n]=d
      }
    }   
    
  }	
}}}


J._extend=function(eL){with(JSC){with(_t){  // parses classes, eL = extendList
  //alert("extending")
  var eA=["JSClass"] //extendArray, used for putting classes and subclasses in the correct order
  
  for(var n3=0;n3<eA.length;n3++){ 
  	var SN=eA[n3] // superclass name  	
  	if(!eL[SN]) continue; // no subclasses to parse
    var S=_c[SN]
    if(!S) return ["extend","'"+SN+"'",eL]    
    for(var nn=0;nn<eL[SN].length;nn++){ // looping trough extendlist      
      var c=eL[SN][nn],cN=c.Name  // subclass name               
      
      //if(typeof cN=="function"){ c=cN; cN=c.Name }
      //else c=window[eL[SN][nn]]
      
      eA[eA.length]=cN //putting the next subclass array to be parsed      
      
      var c_s=c.toString()			
      var c_args=c_s.slice(c_s.indexOf("(")+1,c_s.indexOf(")")).replace(/ /g,""),c_body=c_s.slice(c_s.indexOf("{")+1,c_s.lastIndexOf("}"))
      
          
      var T=[c[t0],c[t1],c[t2]]
      if(typeof c[t3]=="function" || typeof c[t3]=="object") T=T.concat([c[t3][t0],c[t3][t1]])  
			      
     // var re_args=c_args?(c_args+",").replace(_RE.args,"var $1=$1_;"):"" //reassigning named arguments

      c_body="var t=this,c=arguments.callee;UID=JSC._Uc++;"
      +"if(!t['$UID']){ var I=c['@i'];" 
      +"t['$UID']=UID;" 
      +"JSC._i[UID]=I[I.length]=t;"  // assigning/counting instances to global and class object
      +"t.Class=c.Class;t.Static=c"
      +"};"+(S!=JSC?"t.Super=c['@s'];":"")          
      +";with(t){ "//+ st_ 
      +(S!=JSC?c_body.search(_RE.Super)==-1?"Super();\n":"":"Super=null;")
      +"Class.Scope=c.Class;t=c=null; " 
      //+re_args
      +c_body +" } "
      //NOTE: most of the text could probably be put outside of this func 
       
      var tc=c,t
      
			//c_args=c_args.replace(/,/g,"_,")+"_" //renaming arguments, for correct reassigning later
			
			
			c=_c[cN]=new Function(c_args,c_body);
      
      if(tc._c) tc._c[cN]=c // putting it in outerclass
      else window[cN]=c
      
      
      for(var i in tc){      	
      	t=tc[i]
      	if(typeof t=="function"&&t._e){      		      		
      		t.Name=i
      		t._c=c // outer class reference
      		t.Extends(t._e)
				}      
      }
      
      //var _S=S==JSC?_sp:S
      for(var i in _sp) c[i]=_sp[i] // assigning static public to class
      
      // needs to be done here, because using new c reference
      _pub[cN]=new Function // using new Function instead of eval(NS4 bug) for method inheritance 
      
      var sp,p=c.prototype=_pub[cN].prototype=new _pub[SN]	// assigning all accessors to pub, since only debugger will check for validity of use		    
      
      var P=[p,p,p,c,c] //all methods are parsed into here
      sp=_pub[SN].prototype
      var SP=[sp,sp,sp,S,S] //super methods reference
      
      _parseMethods(T,P,c,cN,SP)  
      
      p["is"+cN]=true // for easy instanceOf checking 
       
             
      c['$p']=tc[t4], // the package
      c['@i']=[], //instances          
      c['@s']=S
      c['$e']=cN + " constructor"
      
      c.Class=P[0].Class=new _Cl(cN,S.Class,S==JSC?c.Class:S.Class.BaseClass) // new class meta object        
      
      if(p=_p[cN]) p[cN]=c // putting the class into the package namespace
       
      if(typeof tc[t3]=="function"){
        var St_s=tc[t3].toString(),St_args=St_s.slice(St_s.indexOf("(")+1,St_s.indexOf(")"))+" ",St_body=St_s.slice(St_s.indexOf("{"))		
        			       
        c[t3]=new Function(St_args,St_body.replace("{",ss)) // initializing static,has to be done before assigning statpub to class              
      	//c[t3][t0]=P[3] // public
      	c[t3]['$e']=cN+" Static constructor"
      	_s[_s.length]=c
      }
      
    }
   
  }
}}}


J._parseMethods=function(T,P,c,cN,SP){ with(JSC){with(_t){	

  for(var n=0;n<T.length;n++){      // looping through methods
    if(!T[n]) continue;         
    for(var i=0;i<_nL.length;i++) if(T[n][_nL[i]]!=Object.prototype[_nL[i]]) T[n][i]=T[n][_nL[i]]; // ex. T[n].0="toString"		
    // ^ natives
    for(var i in T[n]){        
      var t=T[n][i],p=P[n],pp
      if(typeof t!="function"){    
        p[i]=t  
        continue;
      }
      
      if(!T[n]['$p']){
		    
		    var t_s=t.toString(),t_args=t_s.slice(t_s.indexOf("(")+1,t_s.indexOf(")")).replace(/ /g,""),t_body=t_s.slice(t_s.indexOf("{"))		
		    //if(_mL) for(var nm in _mL) if(typeof JSC[nm].exec=="function") t_s=JSC[nm].exec({Method:{body:t_body,name:i,type:ty[n]},Class:{name:cN},Super:{name:SN}})        
		    // FIX! module hooking
		    
		    if(_nL[i]) i=_nL[i] // if this is native function, ex. i=0
		   	re_args=t_args?(t_args+",").replace(_RE.args,"var $1=$1_;"):""
		   
		    pp=p[i]=new Function(t_args?t_args.replace(/,/g,"_,")+"_":"",t_body.replace("{",s[n]+re_args))
		    
		    if(t._p){ // has been decorated, _p is the parsed method
		    	(p[i]=t._p).Orig=pp		    	
		    }
		    p=p[i]
		    p['$t']=ty[n] //method type 
		    p['$p']=true // parsed
		  	p['$n']=i //method name		    
		  	
		  }else p=p[i]=t
		  
		  if(c){  //extending		    
		    if(SP[n][i]){
		    	p.Super=SP[n][i] // setting reference to super method if exists		    	
		    }
		    // FIX! Super		    
		    //debugging info
		    
		    p['$cN']=cN //class name in scope
		    p['@c']=c
		    p['C']=c.Class
		    p['$e']=cN+"."+i // NOTE: does not work proper.. for decoration of instance 
		    
      }
       /* INFO: 
      	Not setting this == P[n][i] since the "this" object is not known at this time
      	Instead, JSC._ar is used.. 
      	This facilitates calling method.Super() in the correct scope
      	and for decorators, method.Orig() 
      */
    }       
  }
}}}


p=J._Cl=function(n,s,b){
	var t=this
	t.name=n //name
	t.Super=s //super		
	t.BaseClass=b //baseClass
}

J.Class=new p(J.Name)




J.setModulePath=function(s){		
	if(typeof s!="string") return
	JSC.modulePath=s.charAt(-1)=="/"?s:s+"/"   
}
J.hookModule=function(s){ 
  if(typeof s!="string"||s.search(/\/|(\.js)/)!=-1 ) return    
  JSC._mL[s]=true  
  document.write("<SCRIPT SRC='"+JSC._mP+s+".js'><\/SCRIPT>")  
}
J._mL={} //moduleList
J._mP="modules/" // == modulePath


onload=function(){with(JSC){
 	p=_aN.Protected
 	JSC._RE={
		args:/([a-zA-Z_0-9 ]+),/g,
  	fname:/n?function ?([a-zA-Z_0-9]*)/,
  	Static:new RegExp("Static *\\. *(Protected"+(p?"|"+p:"")+")","g"),
  	//Public:/([^a-zA-Z_0-9])this( |\.)/g,
  	pack:new RegExp(" *\\. *(Protected"+(p?"|"+p:"")+")","g"),
  	Super:/[^a-zA-Z_0-9.] *Super *\(/,
  	Private:/[^a-zA-Z_0-9.] *Private\./
	}
 	
 	var d=new Date().getTime()
  //if(JSC.Parse) var err=JSC.Parse() 
   
  //if(JSC.ParseError&&err) JSC.ParseError(err)
 
 	_decorate(_dL)
 	_extend(_exL)
 	   
  
  for(var n in _s){  	  	  	
	  	
  	_s[n].Static() // calling static constructor, nested classes ready at this point    
   
  	delete _s[n].Static;
  }
  
  //for(var n in _si) window[n]= new _si[n] // singleton stuff , NOTE: needs refactoring
  
  _fireE("INIT","LOAD","AFTERLOAD") 
  

  for(var n in _mL) if(typeof JSC[n].finalize=="function") JSC[n].finalize()        
  //JSC.extendList=JSC._dL=null
  JSC.parseTime=new Date().getTime()-d
	
}}

onunload=function(){with(JSC){	
	_fireE("UNLOAD")	
		
	for(var i in _c){
		i=_c[i]				
		if(i==JSC) continue				
		if(typeof i.finalize=="function") i.finalize()
	}	 
} JSC=JSClass=null
	if(Browser.NS4) document.close()
}


onerror=function(e,f,l){with(JSC._t){
	c=arguments.caller
	
	if(!c) return	
	c=c.callee,n=c['$e']//c.Name||c['$n']||c.Class?c.Class.name:0
	
	if(!n||n=="Function") return
	alert(""
		+"\nError: "+e
		+"\nFunc: "+n
		+"\nLine: "+l
		+"\nFile: "+f
	)
	return true
}}



I=Import=function(){with(Import){	  
  var a=arguments,iL=JSC._iL,t="",p,s
  for(var i=0;i<a.length;i++){
  	s=a[i]  	       
    if(typeof s!="string"||iL[s]) continue; // maybe add error            
    p=s.split(".")
    if(p.length>1){
	    if(_rP){
	    	if(p[0]!=_rP) continue;          
	    	s=s.replace(_rP,"")
	    }	        
	    for(var n=0,l=p.length-1,r=window;n<l;n++){    	
	    	if(!r[p[n]]) r[p[n]]={} //creating namespace 
	    	r=r[p[n]]
	    }
	    if(s.indexOf("*")==-1) JSC._p[p[l]]=r // mapping the class name to a package reference
    }  
    iL[s]=true      
    t+='<SCRIPT src="'+_cP+ s.replace(/\./g,"/").replace(/\$/,_var).replace("*","_Package")+'.js"><\/SCRIPT>'
  	
  }  
  if(_log) alert(t)
  document.write(t)
  return t
}} 
I.Name="Import" // == Name
I._log=false // == log
I._var="$/"+Browser.name+"_" // == variant
I._rP="" // == rootPack == rootPackage

I.setRootPackage=function(s){
	if(typeof s!="string") return
	this.rootPack=s+"."
}
I.setClassPath=function(s){ 
  if(typeof s!="string") return;
  this._cP=s//.charAt(-1)=="/"?s:s+"/"
}
I._cP="" // == classPath

/*
J.alert=function(a){ //simple alert extension
	if(this.doAlert)
		alert(a)
}
J.doAlert=false
*/


t=p=Jc=I=J=PMM=s=null

