
Import("wildwest.DrinkingHabit")

GunFighter=function GunFighter(_name,_health,_skill,_gun){
	setName(_name)
	setHealth(_health)		
	setSkill(_skill)	
	setGun(_gun||0)
} 
GunFighter.Extends(JSC)
GunFighter.Applies("DrinkingHabit")
GunFighter.Abstract=true

GunFighter.Protected={
	name:"John Doe",
	gun:null, 
	skill:30, 
	health:5,
	setHealth:function(n){
		if(typeof n=="number")
			health=Math.round(n)
	}
}
GunFighter.Public={
	setName:function(nm){
		if(typeof nm!="string") return
			name=nm
	},
	getName:function(){ 
		return name
  },
  
  wound:function(n){
  	if(typeof n=="number")
  		health-=Math.round(n)
  },
  isDead:function(){
  	return health>0?false:true
  },	
		
	shoot:function(person){ // 		
		//if(!person||!person.isGunFighter) return
		var dmg,aim=(Math.random()*GunFighter.toHit)
		
		if(aim<skill){ // a hit
			dmg=Math.round(gun.minDamage+Math.random()*(gun.maxDamage-gun.minDamage))
			person.wound(dmg)			
		}
		return dmg
	},	
	setGun:function(n){		
		if(n<GunFighter.gunType.length)
			gun=GunFighter.gunType[n]
	},
	drawGun:function(){
		return gun
	},
	
	setSkill:function(n){
		skill=n
	},
	getAim:function(){
		return skill
	},
	getHealth:function(){
		return health		
	}	
	
}

GunFighter.Static=function(){
	gunType=[new Gun("sixshooter",1,10,20),new Gun("rifle",8,15,10)]
}
GunFighter.Static.Protected={
	gunType:null,
	toHit:100		
}

GunFighter.Gun=function(_name,_min,_max,_speed){
	name=_name
	minDamage=_min
	maxDamage=_max	
}
GunFighter.Gun.Extends(JSC)
GunFighter.Gun.Protected={
	name:"",
	maxDamage:0,
  minDamage:0  
}
